Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_node.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_node.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_node.f90	(revision 2528)
@@ -0,0 +1,560 @@
+module m_dom_node
+
+use m_dom_types
+use m_dom_nodelist
+use m_dom_namednodemap
+use m_dom_debug
+use m_dom_error
+
+use m_strings
+
+private
+
+  !-------------------------------------------------------   
+  ! METHODS FOR NODES
+  !-------------------------------------------------------   
+
+  public :: getNodeName
+  public :: getNodevalue	
+  public :: getNodeType
+  public :: hasChildNodes
+  public :: hasAttributes
+  public :: getParentNode
+  public :: getFirstChild
+  public :: getLastChild
+  public :: getNextSibling
+  public :: getPreviousSibling
+  public :: getOwnerDocument
+  public :: getAttributes
+  public :: getChildNodes
+  public :: setNodeValue
+  public :: appendChild
+  public :: removeChild
+  public :: replaceChild
+  public :: cloneNode  
+  public :: isSameNode
+  public :: insertBefore
+
+  private :: name_len, value_len
+
+CONTAINS
+
+  pure function name_len(node)
+    type(fnode), pointer :: node
+    integer :: name_len
+
+    name_len = len_trim(node % nodeName)
+
+  end function name_len
+
+  pure function value_len(node)
+    type(fnode), pointer :: node
+    integer :: value_len
+
+    value_len = len_trim(node % nodeValue)
+
+  end function value_len
+
+  !-----------------------------------------------------------
+  !  METHODS FOR NODES
+  !-----------------------------------------------------------
+  function getNodeName(node)
+
+    type(fnode), pointer :: node
+!    character(len=len_trim(node%nodeName)) :: getNodeName
+    type(string)  :: getNodeName
+    if (.not. associated(node))  &
+               call dom_error("getNodeName",0,"Node not allocated")
+    getNodeName = node % nodeName
+
+  end function getNodeName
+
+  !-----------------------------------------------------------
+
+  function getNodeValue(node)
+
+    type(fnode), pointer :: node
+!    character(len=len_trim(node%nodeValue)) :: getNodeValue
+    type(string)  :: getNodeValue
+
+    if (.not. associated(node))  &
+               call dom_error("getNodeValue",0,"Node not allocated")
+    getNodeValue = node % nodeValue
+
+  end function getNodeValue
+
+  !-----------------------------------------------------------
+
+  function getNodeType(node)
+
+    type(fnode), pointer :: node
+    integer :: getNodeType
+
+    if (.not. associated(node)) call dom_error("getNodeType",0,"Node not allocated")
+    getNodeType = node % nodeType
+
+  end function getNodeTYpe
+
+  !-----------------------------------------------------------
+
+  function hasChildNodes(node)
+
+    type(fnode), pointer :: node
+    logical :: hasChildNodes
+
+    if (.not. associated(node)) call dom_error("hasChildNodes",0,"Node not allocated")
+    hasChildNodes = associated(node % firstChild)
+
+  end function hasChildNodes
+
+  !-----------------------------------------------------------
+
+  function hasAttributes(node)
+
+    type(fnode), pointer    :: node
+    logical                 :: hasAttributes
+
+    hasAttributes = .false.
+    if (.not. associated(node)) call dom_error("hasAttributes",0,"Node not allocated")
+    if (node % nodeType /= ELEMENT_NODE) RETURN
+    if ( getLength(node%attributes) > 0) hasAttributes = .true.
+
+  end function hasAttributes
+
+  !-----------------------------------------------------------
+
+  function getParentNode(node)
+
+    type(fnode), pointer    :: node
+    type(fnode), pointer    :: getParentNode
+
+    if (.not. associated(node)) call dom_error("getParentNode",0,"Node not allocated")
+    getParentNode => node % parentNode
+    
+  end function getParentNode
+  
+  !-----------------------------------------------------------
+
+  function getFirstChild(node)
+
+    type(fnode), pointer    :: node
+    type(fnode), pointer    :: getFirstChild
+
+    if (.not. associated(node)) call dom_error("getFirstChild",0,"Node not allocated")
+    getFirstChild => node % firstChild
+
+  end function getFirstChild
+
+  !-----------------------------------------------------------
+
+  function getLastChild(node)
+
+    type(fnode), pointer :: node
+    type(fnode), pointer    :: getLastChild
+
+    if (.not. associated(node)) call dom_error("getLastChild",0,"Node not allocated")
+    getLastChild => node % lastChild
+
+  end function getLastChild
+
+  !-----------------------------------------------------------
+
+  function getNextSibling(node)
+
+    type(fnode), pointer :: node
+    type(fnode), pointer    :: getNextSibling
+
+    if (.not. associated(node)) call dom_error("getNextSibling",0,"Node not allocated")
+    getNextSibling => node % nextSibling
+
+  end function getNextSibling
+
+  !-----------------------------------------------------------
+
+  function getPreviousSibling(node)
+
+    type(fnode), pointer     :: node
+    type(fnode), pointer    :: getPreviousSibling
+
+    if (.not. associated(node)) call dom_error("getPreviousSibling",0,"Node not allocated")
+    getPreviousSibling => node % previousSibling
+
+  end function getPreviousSibling
+
+  !-----------------------------------------------------------
+
+  function getOwnerDocument(node)
+
+    type(fnode), pointer    :: node
+    type(fnode), pointer    :: getOwnerDocument
+
+    if (.not. associated(node)) call dom_error("getOwnerDocument",0,"Node not allocated")
+    getOwnerDocument => node % ownerDocument
+
+  end function getOwnerDocument
+
+  !----------------------------------------------------------- 
+
+  function getChildNodes(node) result(nodelist)
+    
+    type(fnode), pointer        :: node
+    type(fnodeList), pointer    :: nodelist      !!! NB nodeList
+
+    type(fnode), pointer        :: np
+
+    if (.not. associated(node)) call dom_error("getChildNodes",0,"Node not allocated")
+    nodelist => null()
+    np => node%firstChild
+    do 
+       if (.not. associated(np)) exit
+       call append(nodelist,np)
+       np => np%nextSibling
+    enddo
+
+  end function getChildNodes
+
+  !----------------------------------------------------------- 
+
+  function getAttributes(node)
+
+    type(fnode), pointer         :: node
+    type(fnamedNodeMap), pointer :: getAttributes       !!! NB namedNodeMap
+    
+    if (.not. associated(node))  &
+               call dom_error("getAttributes",0,"Node not allocated")
+    getAttributes => node % attributes
+
+  end function getAttributes
+
+  !----------------------------------------------------------- 
+
+  subroutine setNodeValue(node, value)
+
+    type(fnode), pointer :: node
+    character(len=*), intent(in) :: value
+    
+    if (.not. associated(node))  &
+               call dom_error("setNodeValue",0,"Node not allocated")
+
+    select case(node % nodeType)
+
+    case(ATTRIBUTE_NODE)
+       node % nodeValue = trim(value)    !!AG: use just value ??
+
+    case(COMMENT_NODE)
+       node % nodeValue = value
+
+    case(TEXT_NODE)
+       node % nodeValue = value
+
+    case(PROCESSING_INSTRUCTION_NODE)
+       node % nodeValue = value
+
+    case(CDATA_SECTION_NODE)
+       node % nodeValue = value
+
+    end select
+
+  end subroutine setNodeValue
+
+  !-----------------------------------------------------------
+  
+  function appendChild(node, newChild)
+    type(fnode), pointer :: node
+    type(fnode), pointer :: newChild
+    type(fnode), pointer :: appendChild
+    
+    if (.not. associated(node))  & 
+               call dom_error("appendChild",0,"Node not allocated")
+
+    if ((node%nodeType /= ELEMENT_NODE) .and. &
+        (node%nodeType /= DOCUMENT_NODE)) &
+    call dom_error("appendChild",HIERARCHY_REQUEST_ERR, &
+           "this node cannot have children")
+
+    if (.not.(associated(node % firstChild))) then
+       node % firstChild => newChild
+    else 
+       newChild % previousSibling   => node % lastChild
+       node % lastChild % nextSibling => newChild 
+    endif
+
+    node % lastChild               => newChild
+    newChild % parentNode          => node
+    newChild % ownerDocument       => node % ownerDocument
+    node%nc  = node%nc + 1
+
+    appendChild => newChild
+
+  end function appendChild
+
+  !-----------------------------------------------------------
+  
+  function removeChild(node, oldChild)
+
+    type(fnode), pointer :: removeChild
+    type(fnode), pointer :: node
+    type(fnode), pointer :: oldChild
+    type(fnode), pointer :: np
+    
+    if (.not. associated(node)) call dom_error("removeChild",0,"Node not allocated")
+    np => node % firstChild
+
+    do while (associated(np))
+       if (associated(np, oldChild)) then   ! Two argument form 
+                                              !  of associated()
+          if (associated(np,node%firstChild)) then
+             node%firstChild => np%nextSibling
+             if (associated(np % nextSibling)) then
+                np%nextSibling % previousSibling => null()
+             else
+                node%lastChild => null()    ! there was just 1 node
+             endif
+          else if (associated(np,node%lastChild)) then
+             ! one-node-only case covered above
+             node%lastChild => np%previousSibling
+             np%previousSibling%nextSibling => null()
+          else
+             np % previousSibling % nextSibling => np % nextSibling
+             np % nextSibling % previousSibling => np % previousSibling
+          endif
+          node%nc = node%nc -1
+          np % previousSibling => null()    ! Are these necessary?
+          np % nextSibling => null()
+          np % parentNode => null()
+          removeChild => oldChild
+          RETURN
+       endif
+       np => np % nextSibling
+    enddo
+
+    call dom_error("removeChild",NOT_FOUND_ERR,"oldChild not found")
+
+  end function removeChild
+
+ !-----------------------------------------------------------
+  
+  function replaceChild(node, newChild, oldChild)
+
+    type(fnode), pointer :: replaceChild
+    type(fnode), pointer :: node
+    type(fnode), pointer :: newChild
+    type(fnode), pointer :: oldChild
+
+    type(fnode), pointer :: np
+    
+    if (.not. associated(node)) call dom_error("replaceChild",0,"Node not allocated")
+    if ((node%nodeType /= ELEMENT_NODE) .and. &
+        (node%nodeType /= DOCUMENT_NODE)) &
+    call dom_error("replaceChild",HIERARCHY_REQUEST_ERR, &
+           "this node cannot have children")
+
+    np => node % firstChild
+
+    do while (associated(np))    
+       if (associated(np, oldChild)) then
+          if (associated(np,node%firstChild)) then
+             node%firstChild => newChild
+             if (associated(np % nextSibling)) then
+                oldChild%nextSibling % previousSibling => newChild
+             else
+                node%lastChild => newChild    ! there was just 1 node
+             endif
+          else if (associated(np,node%lastChild)) then
+             ! one-node-only case covered above
+             node%lastChild => newChild
+             oldChild%previousSibling%nextSibling => newChild
+          else
+             oldChild % previousSibling % nextSibling => newChild
+             oldChild % nextSibling % previousSibling => newChild
+          endif
+
+          newChild % parentNode      => oldChild % parentNode
+          newChild % nextSibling     => oldChild % nextSibling
+          newChild % previousSibling => oldChild % previousSibling
+          replaceChild => oldChild
+          RETURN
+       endif
+       np => np % nextSibling
+    enddo
+
+    call dom_error("replaceChild",NOT_FOUND_ERR,"oldChild not found")
+
+  end function replaceChild
+
+  !-----------------------------------------------------------
+
+  function cloneNode(node, deep)             
+    type(fnode), pointer :: cloneNode
+    type(fnode), pointer :: node
+
+    logical, optional :: deep
+    logical           :: do_children
+
+    type(fnode), pointer :: original
+    type(fnode), pointer :: parent_clone
+    
+    if (.not. associated(node)) call dom_error("cloneNode",0,"Node not allocated")
+
+    do_children = .false.
+    if (present(deep)) then
+       do_children = deep
+    endif
+    
+    original => node             ! Keep node
+    cloneNode => null()
+    parent_clone => null()
+    call recursive_clone(original, cloneNode)
+    cloneNode%parentNode => null()     ! as per specs   , superfÃluous
+ 
+  Contains
+
+    recursive subroutine recursive_clone(original, cloneNode)
+      type(fnode), pointer :: original        ! node to clone
+      type(fnode), pointer :: cloneNode       ! new node
+
+      type(fnode), pointer :: np, clone
+      type(fnode), pointer :: previous_clone, attr, newattr
+      type(string)         :: name
+      logical :: first_sibling
+      integer :: i
+
+      np => original
+      previous_clone => null()
+      first_sibling = .true.
+      do 
+
+         ! Keep going across siblings
+         ! (2nd and lower levels only)
+
+         if (.not.(associated(np))) EXIT
+
+
+         !----------------------------------------------------!
+         clone => createNode()
+         if (first_sibling) then
+            cloneNode => clone       ! Rest of siblings are chained
+                                     ! automatically, but must not
+                                     ! be aliases of cloneNode !!
+            first_sibling = .false.
+         endif
+         clone % nodeName    = np % nodeName
+         name = np%nodeName
+         if (dom_debug) print *, "Cloning ", char(name)
+         clone % nodeValue   = np % nodeValue
+         clone % nodeType    = np % nodeType
+         clone % ownerDocument => np % ownerDocument
+         clone % parentNode  => parent_clone
+         !
+         ! always deep copy attributes, as per specs
+         ! Note that this will not work for "deep" attributes, with
+         ! hanging entity nodes, etc
+         if (associated(np % attributes)) then
+            do i = 0, getLength(np%attributes) - 1
+               attr => item(np%attributes,i)
+               newattr => createNode()
+               newattr%nodeName = getNodeName(attr)
+               newattr%nodeValue = getNodeValue(attr)
+               newattr%nodeType = ATTRIBUTE_NODE
+               call append(clone%attributes, newattr)
+            enddo
+         endif
+
+         ! Deal with first sibling
+         if (associated(previous_clone)) then
+            if (dom_debug) print *, "linking to previous sibling"
+            previous_clone%nextSibling => clone
+            clone%previousSibling => previous_clone
+         else
+            if (dom_debug) print *, "marking as first child of parent"
+            if (associated(parent_clone))  &
+                           parent_clone%firstChild => clone
+         endif
+
+         ! Deal with last sibling
+         if (.not. associated(np%nextSibling)) then
+            if (dom_debug) print *, "this is the last sibling"
+            if (associated(parent_clone)) then
+               if (dom_debug) print *, "marking as last child of parent"
+               parent_clone%lastChild => clone
+            endif
+         endif
+            
+         if (do_children .and. associated(np%firstChild)) then
+            parent_clone => clone
+            if (dom_debug) print *, ".... going for its children"
+            call recursive_clone(np%firstChild,clone%firstChild)
+            parent_clone => clone%parentNode
+         endif
+
+         if (associated(np,node)) then
+            if (dom_debug) print *, "No more siblings of ", char(name)
+            EXIT  ! no siblings of master node
+         endif
+         np => np % nextSibling
+         previous_clone => clone
+
+      enddo 
+
+    end subroutine recursive_clone
+
+  end function cloneNode
+
+  !-----------------------------------------------------------
+
+  function isSameNode(node1, node2)    ! DOM 3.0
+    type(fnode), pointer :: node1
+    type(fnode), pointer :: node2
+    logical :: isSameNode
+
+    isSameNode = associated(node1, node2)
+
+  end function isSameNode
+
+  !-----------------------------------------------------------
+
+  function insertBefore(node, newChild, refChild)
+    type(fnode), pointer :: insertBefore
+    type(fnode), pointer :: node
+    type(fnode), pointer :: newChild
+    type(fnode), pointer :: refChild
+    type(fnode), pointer :: np
+
+    if (.not. associated(node)) call dom_error("insertBefore",0,"Node not allocated")
+    if ((node%nodeType /= ELEMENT_NODE) .and. &
+        (node%nodeType /= DOCUMENT_NODE)) &
+    call dom_error("insertBefore",HIERARCHY_REQUEST_ERR, &
+           "cannot insert node here")
+
+    if (.not.associated(refChild)) then
+       insertBefore => appendChild(node, newChild)
+       RETURN
+    endif
+
+    np => node % firstChild
+    do while (associated(np))
+       if (associated(np, refChild)) then
+          if (associated(np,node%firstChild)) then
+             node%firstChild => newChild
+          else
+             refChild%previousSibling%nextSibling => newChild
+          endif
+
+          refChild % previousSibling => newChild
+          newChild % nextSibling => refChild
+          newChild % parentNode => node
+          newChild % ownerDocument => refChild % ownerDocument
+          insertBefore => newChild
+          RETURN
+       endif
+       np => np % nextSibling
+    enddo
+
+    call dom_error("insertBefore",NOT_FOUND_ERR,"refChild not found")
+
+  end function insertBefore
+
+!----------------------------------------------------------------------
+
+end module m_dom_node
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_nodelist.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_nodelist.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_nodelist.f90	(revision 2528)
@@ -0,0 +1,89 @@
+module m_dom_nodelist
+
+use m_dom_types
+
+private
+
+public :: item
+public :: getLength
+public :: append
+
+interface append
+   module procedure append_nl
+end interface
+
+interface item
+   module procedure item_nl
+end interface
+
+interface getLength
+   module procedure getLength_nl
+end interface
+
+CONTAINS
+
+  !-----------------------------------------------------------
+  ! METHODS FOR NODELISTS
+  !-----------------------------------------------------------
+  function item_nl(nodeList, i)
+    
+    integer, intent(in)             :: i
+    type(fnodeList), pointer        :: nodeList
+    type(fnode), pointer            :: item_nl
+    
+    type(flistNode), pointer :: lp
+    integer :: n
+
+    item_nl => null()            ! In case there is no such item
+    if (.not. associated(nodeList)) RETURN
+
+    lp => nodeList%head
+    n = -1
+    do 
+       if (.not. associated(lp))  exit
+       n = n + 1
+       if (n == i) then
+          item_nl => lp%node
+          exit
+       endif
+       lp => lp%next
+    enddo
+
+  end function item_nl
+
+  !----------------------------------------------------------- 
+
+  function getLength_nl(nodeList)
+    
+    type(fnodeList), pointer :: nodeList
+    integer                  :: getLength_nl
+
+    if (.not. associated(nodeList)) then
+       getLength_nl = 0
+    else
+       getLength_nl = nodeList % length
+    endif
+
+  end function getLength_nl
+
+  subroutine append_nl(nodeList,node)
+    type(fnodeList), pointer :: nodeList
+    type(fnode), pointer :: node
+
+    if (.not. associated(nodeList)) then
+       allocate(nodeList)
+       nodelist%length = 1
+       allocate(nodelist%head)
+       nodelist%head%node => node
+       nodelist%tail => nodelist%head
+    else
+       allocate(nodelist%tail%next)
+       nodelist%tail%next%node => node
+       nodelist%tail => nodelist%tail%next
+       nodelist%length = nodelist%length + 1
+    endif
+
+  end subroutine append_nl
+
+end module m_dom_nodelist
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_parse.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_parse.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_parse.f90	(revision 2528)
@@ -0,0 +1,152 @@
+module m_dom_parse
+
+  use m_dom_types
+  use m_dom_element
+  use m_dom_document
+  use m_dom_node
+!  use m_dom_namednodemap
+  use m_dom_debug
+
+  use flib_sax
+
+  implicit none
+  
+  private
+
+  public :: parsefile
+
+  type(fnode), pointer, private, save  :: main
+  type(fnode), pointer, private, save  :: current
+
+
+CONTAINS
+
+  subroutine begin_element_handler(name,attrs)
+
+    character(len=*),   intent(in) :: name
+    type(dictionary_t), intent(in) :: attrs
+   
+    type(fnode), pointer :: temp
+    character(len=400)   :: attr_name, attr_value
+    integer              :: status
+    integer              :: i
+
+    if (dom_debug) print *, "Adding node for element: ", name
+
+    temp => createElement(name)
+    current => appendChild(current,temp)
+!
+!   Add attributes
+!
+    do i = 1, len(attrs)
+       call get_name(attrs, i, attr_name, status)
+       call get_value(attrs, attr_name, attr_value, status)
+       if (dom_debug) print *, "Adding attribute: ", &
+                       trim(attr_name), ":",trim(attr_value)
+       call setAttribute(current,attr_name,attr_value)
+    enddo
+
+  end subroutine begin_element_handler
+
+!---------------------------------------------------------
+
+  subroutine end_element_handler(name)
+    character(len=*), intent(in)     :: name
+
+!!AG for IBM    type(fnode), pointer :: np
+
+    if (dom_debug) print *, "End of element: ", name
+!!AG for IBM    np => getParentNode(current)
+!!AG for IBM    current => np
+    current => getParentNode(current)
+  end subroutine end_element_handler
+
+!---------------------------------------------------------
+
+  subroutine pcdata_chunk_handler(chunk)
+    character(len=*), intent(in) :: chunk
+
+    type(fnode), pointer :: temp, dummy
+    
+    if (dom_debug) print *, "Got PCDATA: |", chunk, "|"
+
+    temp => createTextNode(chunk)
+    dummy => appendChild(current,temp)
+
+  end subroutine pcdata_chunk_handler
+
+!---------------------------------------------------------
+
+  subroutine comment_handler(comment)
+    character(len=*), intent(in) :: comment
+
+    type(fnode), pointer :: temp, dummy
+
+    if (dom_debug) print *, "Got COMMENT: |", comment, "|"
+
+    temp => createComment(comment)
+    dummy => appendChild(current,temp)
+
+  end subroutine comment_handler
+!---------------------------------------------------------
+  subroutine cdata_section_handler(chunk)
+    character(len=*), intent(in) :: chunk
+
+    type(fnode), pointer :: temp, dummy
+    
+    if (dom_debug) print *, "Got CDATA_SECTION: |", chunk, "|"
+
+    temp => createCdataSection(chunk)
+    dummy => appendChild(current,temp)
+
+  end subroutine cdata_section_handler
+
+!***************************************************
+!   PUBLIC PROCEDURES
+!***************************************************
+
+
+  function parsefile(filename, verbose, sax_verbose)
+
+    character(len=*), intent(in) :: filename
+    logical, intent(in), optional :: verbose
+    logical, intent(in), optional :: sax_verbose
+
+    type(fnode), pointer :: parsefile
+
+    logical :: sax_debug = .false.
+
+    type(xml_t) :: fxml
+    integer :: iostat
+
+    if (present(verbose)) then
+       dom_debug = verbose
+    endif
+
+    if (present(sax_verbose)) then
+       sax_debug = sax_verbose
+    endif
+    
+    call open_xmlfile(filename, fxml, iostat)
+
+    PRINT *,'filename : ',filename
+    if (iostat /= 0) then
+       stop "Cannot open file."
+    endif
+
+    main => createDocumentNode()
+    current => main
+
+    call xml_parse(fxml,  &
+           begin_element_handler, end_element_handler, pcdata_chunk_handler, &
+           comment_handler, cdata_section_handler=cdata_section_handler, &
+           verbose = sax_debug)    
+    call close_xmlfile(fxml)
+
+    parsefile => main
+    if (dom_debug) print *, "Number of allocated nodes: ", getNumberofAllocatedNodes()
+
+  end function parsefile
+
+
+END MODULE m_dom_parse
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_types.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_types.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_types.f90	(revision 2528)
@@ -0,0 +1,195 @@
+Module m_dom_types
+
+  use m_strings
+
+  implicit none
+
+  private
+
+  !-------------------------------------------------------   
+  ! A GENERIC NODE
+  !-------------------------------------------------------   
+  type, public :: fnode
+     type(string)         :: nodeName    
+     type(string)         :: nodeValue   
+!!!     character(len=200)    :: nodeName  = ""
+!!!     character(len=200)    :: nodeValue = ""
+     integer              :: nc              = 0 
+     integer              :: nodeType        = 0
+     type(fnode), pointer :: parentNode      => null()
+     type(fnodeList), pointer :: childNodes  => null()  ! New
+     type(fnode), pointer :: firstChild      => null()
+     type(fnode), pointer :: lastChild       => null()
+     type(fnode), pointer :: previousSibling => null()
+     type(fnode), pointer :: nextSibling     => null()
+     type(fnode), pointer :: ownerDocument   => null()
+     type(fnamedNodeMap), pointer :: attributes => null()
+  end type fnode
+
+  !-----------------------------------------------------------
+  !  ONE WAY TO IMPLEMENT A NAMEDNODEMAP  (dictionary)
+  !-----------------------------------------------------------
+
+  ! Linked list of name/node pairs, with overall length variable
+
+  type, public :: fnamedNode
+     type(string)                   :: name
+!!!     character(len=100)            :: name
+     type(fnode), pointer          :: node => null()
+     type(fnamedNode), pointer     :: next => null()
+  end type fnamedNode
+
+  type, public :: fnamedNodeMap
+     integer :: length = 0
+     type(fnamedNode), pointer  :: head => null()
+     type(fnamedNode), pointer  :: tail => null()
+  end type fnamedNodeMap
+
+  !-----------------------------------------------------------
+  !  ONE WAY TO IMPLEMENT A NODELIST 
+  !-----------------------------------------------------------
+
+  type, public :: flistNode
+     type(fnode), pointer          :: node => null()
+     type(flistNode), pointer      :: next => null()
+  end type flistNode
+
+  type, public :: fnodeList
+     integer                      :: length = 0
+     type(flistNode), pointer     :: head => null()
+     type(flistNode), pointer     :: tail => null()
+  end type fnodeList
+
+!========================================================================
+  integer, save, private          :: allocated_nodes = 0
+!========================================================================
+
+  !-------------------------------------------------------   
+  ! NODETYPES
+  !-------------------------------------------------------   
+  integer, parameter, public :: ELEMENT_NODE                = 1
+  integer, parameter, public :: ATTRIBUTE_NODE              = 2
+  integer, parameter, public :: TEXT_NODE                   = 3
+  integer, parameter, public :: CDATA_SECTION_NODE          = 4
+  integer, parameter, public :: ENTITY_REFERENCE_NODE       = 5
+  integer, parameter, public :: ENTITY_NODE                 = 6
+  integer, parameter, public :: PROCESSING_INSTRUCTION_NODE = 7
+  integer, parameter, public :: COMMENT_NODE                = 8
+  integer, parameter, public :: DOCUMENT_NODE               = 9
+  integer, parameter, public :: DOCUMENT_TYPE_NODE          = 10
+  integer, parameter, public :: DOCUMENT_FRAGMENT_NODE      = 11
+  integer, parameter, public :: NOTATION_NODE               = 12
+
+  public :: node_class
+  public :: createNode
+  public :: destroyNode
+  public :: destroyNamedNodeMap
+  public :: destroyNodeList
+  public :: getNumberofAllocatedNodes
+
+CONTAINS
+
+  function getNumberofAllocatedNodes() result(n)
+    integer   :: n
+
+    n = allocated_nodes
+  end function getNumberofAllocatedNodes
+
+!--------------------------------------------------------------
+  function createNode() result(node)
+    type(fnode), pointer  :: node
+
+    allocate(node)
+    allocated_nodes = allocated_nodes + 1
+
+  end function createNode
+!--------------------------------------------------------------
+
+  function node_class(nodetype) result(class)
+    integer, intent(in) :: nodetype
+    character(len=10)  ::     class
+
+    select case(nodetype)
+    case(ELEMENT_NODE)
+       class = "element"
+    case(ATTRIBUTE_NODE)
+       class = "attribute"
+    case(TEXT_NODE)
+       class = "text"
+    case(COMMENT_NODE)
+       class = "comment"
+    case(DOCUMENT_NODE)
+       class = "document"
+    end select
+  end function node_class
+
+  subroutine destroyNamedNodeMap(nodemap)
+    type(fnamedNodeMap), pointer :: nodemap
+
+    type(fnamednode), pointer  :: nnp
+    type(fnode), pointer       :: ghost
+    
+    if (.not. associated(nodemap)) return
+    nnp => nodemap%head
+    do while (associated(nnp))
+       call unstring(nnp%name)
+       ghost => nnp%node
+       nnp => nnp%next
+       call destroyNode(ghost)      ! We might not want to really destroy
+    enddo
+  end subroutine destroyNamedNodeMap
+
+  subroutine destroyNodeList(nodelist)
+    type(fnodeList), pointer :: nodelist
+
+    type(flistnode), pointer   :: p
+    type(fnode), pointer       :: ghost
+    
+    if (.not. associated(nodelist)) return
+    p => nodelist%head
+    do while (associated(p))
+       ghost => p%node
+       p => p%next
+       call destroyNode(ghost)      ! We might not want to really destroy
+    enddo
+  end subroutine destroyNodeList
+
+  recursive subroutine destroyNode(node)
+    type(fnode), pointer  :: node
+    
+    type(fnode), pointer  :: np, ghost
+    
+    np => node
+    do while (associated(np))
+       if (associated(np%firstChild)) then
+          call destroyNode(np%firstChild)
+       endif
+       if (associated(np%attributes)) call destroyNamedNodeMap(np%attributes)
+       call unstring(np%nodeName)
+       call unstring(np%nodeValue)
+       if (associated(np%previousSibling)) & 
+                np%previousSibling%nextSibling => np%nextSibling
+       if (associated(np%nextSibling)) & 
+                np%nextSibling%previousSibling => np%previousSibling
+       if (associated(np%parentNode)) then
+          if (associated(np%parentNode%firstChild,np)) &
+               np%parentNode%firstChild => null()
+          if (associated(np%parentNode%lastChild,np)) &
+               np%parentNode%lastChild => null()
+       endif
+       if (associated(np,node)) then    
+          deallocate(np)
+          allocated_nodes = allocated_nodes - 1
+          EXIT                           ! do not destroy siblings
+       else
+          ghost => np
+          np => np%nextSibling
+          deallocate(ghost)
+          allocated_nodes = allocated_nodes - 1
+       endif
+    enddo
+    node => null()     ! superfluous ?
+  end subroutine destroyNode
+
+end module m_dom_types
+
